//
//  AddPatientViewController.h
//  MediServe
//
//  Created by Christopher Galindo on 3/27/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "GenderViewController.h"
#import "DateOfBirthViewController.h"
#import "SuffixViewController.h"

@class AddPatientViewController;
@class Patient;
@class User;

@protocol AddPatientViewControllerDelegate <NSObject>

- (void)addPatientViewController:(AddPatientViewController *)controller didAddPatient:(Patient *)patientObject;
- (void)addPatientViewControllerDidCancel:(AddPatientViewController *)controller;
- (void)addPatientViewController:(AddPatientViewController *)controller didAddUser:(User *)userObject;
- (void)addPatientViewController:(AddPatientViewController *)controller didEditPatient:(Patient *)patientObject withIndexPath:(NSIndexPath *)indexPath;

@end

@interface AddPatientViewController : UIViewController <UITextFieldDelegate, GenderViewControllerDelegate, UIPopoverControllerDelegate, DateOfBirthViewControllerDelegate, SuffixViewControllerDelegate>

@property (nonatomic, strong) NSString *clinicianID;
@property (strong, nonatomic) IBOutlet UITextField *ssnTextField;
@property (strong, nonatomic) IBOutlet UITextField *dobTextField;
@property (strong, nonatomic) IBOutlet UITextField *genderTextField;
@property (strong, nonatomic) IBOutlet UITextField *lastNameTextField;
@property (strong, nonatomic) IBOutlet UITextField *firstNameTextField;
@property (strong, nonatomic) IBOutlet UITextField *middleNameTextField;
@property (strong, nonatomic) IBOutlet UITextField *suffixTextField;
@property (strong, nonatomic) IBOutlet UITextField *mrnTextField;
@property (strong, nonatomic) IBOutlet UITextField *accountTextField;
@property (nonatomic, weak) id<AddPatientViewControllerDelegate> delegate;
@property (strong, nonatomic) IBOutlet UIButton *addUserButton;
@property (strong, nonatomic) IBOutlet UIView *addPatientView;
@property (strong, nonatomic) IBOutlet UIView *addUserView;
@property (strong, nonatomic) IBOutlet UITextField *idTextField;
@property (strong, nonatomic) IBOutlet UITextField *userFirstNameTextField;
@property (strong, nonatomic) IBOutlet UITextField *userLastNameTextField;
@property (strong, nonatomic) IBOutlet UITextField *passwordTextField;
@property (strong, nonatomic) NSMutableArray *userList;
@property (nonatomic, assign) BOOL isEditModeOn;
@property (nonatomic, strong) Patient *thePatient;
@property (nonatomic, strong) NSIndexPath *patientIndexPath;
@property (strong, nonatomic) IBOutlet UITextField *roomTextField;
@property (strong, nonatomic) IBOutlet UITextField *bedTextField;
@property (strong, nonatomic) IBOutlet UITextField *unitTextField;
@property (strong, nonatomic) IBOutlet UILabel *roomLabel;
@property (strong, nonatomic) IBOutlet UILabel *bedLabel;
@property (strong, nonatomic) IBOutlet UILabel *unitLabel;
@property (nonatomic, assign) int patientNumber;
@property (nonatomic, strong) UIPopoverController *popoverViewController;

- (IBAction)saveButtonPressed;
- (IBAction)cancelButtonPressed;
- (IBAction)addUserButtonPressed;


@end
