//
//  AddPatientViewController.m
//  MediServe
//
//  Created by Christopher Galindo on 3/27/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "AddPatientViewController.h"
#import "Patient.h"
#import "User.h"

@implementation AddPatientViewController
{
    User *newUser;
    BOOL isPatientMode;
    NSDateFormatter *dateFormatter;
    NSDate *selectedBirthDate;
}

@synthesize clinicianID = _clinicianID;
@synthesize ssnTextField = _ssnTextField;
@synthesize dobTextField = _dobTextField;
@synthesize genderTextField = _genderTextField;
@synthesize lastNameTextField = _lastNameTextField;
@synthesize firstNameTextField = _firstNameTextField;
@synthesize middleNameTextField = _middleNameTextField;
@synthesize suffixTextField = _suffixTextField;
@synthesize mrnTextField = _mrnTextField;
@synthesize accountTextField = _accountTextField;
@synthesize delegate = _delegate;
@synthesize addUserButton = _addUserButton;
@synthesize addPatientView = _addPatientView;
@synthesize addUserView = _addUserView;
@synthesize idTextField = _idTextField;
@synthesize userFirstNameTextField = _userFirstNameTextField;
@synthesize userLastNameTextField = _userLastNameTextField;
@synthesize passwordTextField = _passwordTextField;
@synthesize userList = _userList;
@synthesize isEditModeOn = _isEditModeOn;
@synthesize thePatient = _thePatient;
@synthesize patientIndexPath = _patientIndexPath;
@synthesize roomTextField = _roomTextField;
@synthesize bedTextField = _bedTextField;
@synthesize unitTextField = _unitTextField;
@synthesize roomLabel = _roomLabel;
@synthesize bedLabel = _bedLabel;
@synthesize unitLabel = _unitLabel;
@synthesize patientNumber = _patientNumber;
@synthesize popoverViewController = _popoverViewController;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

/*
 // Implement loadView to create a view hierarchy programmatically, without using a nib.
 - (void)loadView
 {
 }
 */


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
    
    [self.addUserView setHidden:YES];
    [self.idTextField setEnabled:NO];
    [self.userFirstNameTextField setEnabled:NO];
    [self.userLastNameTextField setEnabled:NO];
    [self.passwordTextField setEnabled:NO];
    [self.addUserButton setHidden:YES];
    [self.addUserButton setEnabled:NO];
    [self.roomTextField setHidden:YES];
    [self.roomTextField setEnabled:NO];
    [self.bedTextField setHidden:YES];
    [self.bedTextField setEnabled:NO];
    [self.unitTextField setHidden:YES];
    [self.unitTextField setEnabled:NO];
    [self.roomLabel setHidden:YES];
    [self.bedLabel setHidden:YES];
    [self.unitLabel setHidden:YES];
    
    isPatientMode = YES;
    
    // formatter to display date of birth as a string
    dateFormatter = [[NSDateFormatter alloc] init];
    [dateFormatter setDateStyle:NSDateFormatterShortStyle];
    
    if (self.isEditModeOn)
    {
        self.ssnTextField.text = self.thePatient.ssn;
        self.dobTextField.text = [dateFormatter stringFromDate:self.thePatient.birthDate];
        self.genderTextField.text = self.thePatient.gender;
        self.lastNameTextField.text = self.thePatient.lastName;
        self.firstNameTextField.text = self.thePatient.firstName;
        self.middleNameTextField.text = self.thePatient.middleName;
        self.suffixTextField.text = self.thePatient.suffix;
        self.mrnTextField.text = self.thePatient.mrn;
        self.accountTextField.text = self.thePatient.account;
        
        [self.roomTextField setHidden:NO];
        [self.roomTextField setEnabled:YES];
        [self.bedTextField setHidden:NO];
        [self.bedTextField setEnabled:YES];
        [self.unitTextField setHidden:NO];
        [self.unitTextField setEnabled:YES];
        [self.roomLabel setHidden:NO];
        [self.bedLabel setHidden:NO];
        [self.unitLabel setHidden:NO];
        
        self.roomTextField.text = self.thePatient.admitRoom;
        self.bedTextField.text = self.thePatient.admitBed;
        self.unitTextField.text = self.thePatient.admitUnit;
        
        selectedBirthDate = self.thePatient.birthDate;
        self.title = @"Edit Patient";
    }
    else 
    {
        if ([self.clinicianID isEqualToString:@"Admin"])
        {
            [self.addUserButton setHidden:NO];
            [self.addUserButton setEnabled:YES];
        }
        
        self.mrnTextField.text = [NSString stringWithFormat:@"%09d", self.patientNumber];
        self.accountTextField.text = [NSString stringWithFormat:@"%09d", self.patientNumber];
        self.thePatient = [[Patient alloc] init];
        self.title = @"Add Patient";
    }
}

- (void)viewDidUnload
{
    [self setSsnTextField:nil];
    [self setDobTextField:nil];
    [self setLastNameTextField:nil];
    [self setFirstNameTextField:nil];
    [self setMiddleNameTextField:nil];
    [self setMrnTextField:nil];
    [self setAccountTextField:nil];
    [self setAddUserButton:nil];
    [self setAddPatientView:nil];
    [self setAddUserView:nil];
    [self setGenderTextField:nil];
    [self setSuffixTextField:nil];
    [self setRoomTextField:nil];
    [self setBedTextField:nil];
    [self setUnitTextField:nil];
    [self setRoomLabel:nil];
    [self setBedLabel:nil];
    [self setUnitLabel:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
	return YES;
}

#pragma mark - IBAction methods
- (IBAction)cancelButtonPressed
{
    [self.delegate addPatientViewControllerDidCancel:self];
}

- (IBAction)saveButtonPressed
{
    if (isPatientMode)
    {
        if ([self.lastNameTextField.text length] > 0 && [self.firstNameTextField.text length] > 0 && [self.mrnTextField.text length] > 0 && [self.accountTextField.text length] > 0 && [self.dobTextField.text length] > 0)
        {
            self.thePatient.ssn = self.ssnTextField.text;
            self.thePatient.birthDate = selectedBirthDate;
            self.thePatient.gender = self.genderTextField.text;
            self.thePatient.lastName = self.lastNameTextField.text;
            self.thePatient.firstName = self.firstNameTextField.text;
            self.thePatient.middleName = self.middleNameTextField.text;
            self.thePatient.suffix = self.suffixTextField.text;
            self.thePatient.mrn = self.mrnTextField.text;
            self.thePatient.account = self.accountTextField.text;
            
            self.thePatient.displayName = [[self.thePatient.lastName stringByAppendingString:@", "] stringByAppendingString:self.thePatient.firstName];
            
            // checking if user selected Add Patient or Edit Patient
            if (self.isEditModeOn)
            {
                if ([self.roomTextField.text length] > 0 && [self.bedTextField.text length] > 0 && [self.unitTextField.text length] > 0)
                {
                    self.thePatient.admitRoom = self.roomTextField.text;
                    self.thePatient.admitBed = self.bedTextField.text;
                    self.thePatient.admitUnit = self.unitTextField.text;
                }
                
                if (![self clinicianAlreadyExist])
                {
                    [self.thePatient.myClinicians addObject:self.clinicianID];
                }
                
                [self.delegate addPatientViewController:self didEditPatient:self.thePatient withIndexPath:self.patientIndexPath];
            }
            else
            {
                self.thePatient.isActive = YES;
                self.thePatient.isAdmitted = NO;
                self.thePatient.isDischarged = NO;
                
                // adding clinician to patient
                self.thePatient.myClinicians = [[NSMutableArray alloc] initWithCapacity:1];
                [self.thePatient.myClinicians addObject:self.clinicianID];
                
                // saving patient image to patient's record
                UIImage *image = [UIImage imageNamed:@"add_user.png"];
                NSData *imageData = UIImagePNGRepresentation(image);
                self.thePatient.patientImageData = imageData;
                
                [self.delegate addPatientViewController:self didAddPatient:self.thePatient];
            }
        }
        else
        {
            
        }
    }
    else
    {
        newUser = [[User alloc] init];
        if ([self.idTextField.text length] > 0 && [self.userFirstNameTextField.text length] > 0 && [self.userLastNameTextField.text length] > 0 && [self.passwordTextField.text length] > 0)
        {
            newUser.userID = self.idTextField.text;
            newUser.firstName = self.userFirstNameTextField.text;
            newUser.lastName = self.userLastNameTextField.text;
            newUser.userPassword = self.passwordTextField.text;
            newUser.displayName = [[newUser.lastName stringByAppendingString:@", "] stringByAppendingString:newUser.firstName];
            
            [self.delegate addPatientViewController:self didAddUser:newUser];
        }
    }
}

- (IBAction)addUserButtonPressed
{
    //[self.addPatientView setHidden:YES];
    [self.addUserView setHidden:NO];
    
    [self.ssnTextField setEnabled:NO];
    [self.dobTextField setEnabled:NO];
    [self.genderTextField setEnabled:NO];
    [self.lastNameTextField setEnabled:NO];
    [self.firstNameTextField setEnabled:NO];
    [self.middleNameTextField setEnabled:NO];
    [self.suffixTextField setEnabled:NO];
    [self.mrnTextField setEnabled:NO];
    [self.accountTextField setEnabled:NO];
    
    [self.idTextField setEnabled:YES];
    [self.userFirstNameTextField setEnabled:YES];
    [self.userLastNameTextField setEnabled:YES];
    [self.passwordTextField setEnabled:YES];
    
    isPatientMode = NO;
    
    self.title = @"Add User";
}

#pragma mark - Text Field Delegates
// enables return key to act as next button
- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
    if (isPatientMode)
    {
        if (textField == self.ssnTextField)
        {
            [textField resignFirstResponder];
            [self.dobTextField becomeFirstResponder];
        }
        else if (textField == self.dobTextField)
        {
            [textField resignFirstResponder];
            //[self.genderTextField becomeFirstResponder];
        }
        else if (textField == self.genderTextField)
        {
            [textField resignFirstResponder];
            //[self.lastNameTextField becomeFirstResponder];
        }
        else if (textField == self.lastNameTextField)
        {
            [textField resignFirstResponder];
            [self.firstNameTextField becomeFirstResponder];
        }
        else if (textField == self.firstNameTextField)
        {
            [textField resignFirstResponder];
            [self.middleNameTextField becomeFirstResponder];
        }
        else if (textField == self.middleNameTextField)
        {
            [textField resignFirstResponder];
            [self.suffixTextField becomeFirstResponder];
        }
        else if (textField == self.suffixTextField)
        {
            [textField resignFirstResponder];
            //[self.mrnTextField becomeFirstResponder];
        }
        else if (textField == self.mrnTextField)
        {
            [textField resignFirstResponder];
            [self.accountTextField becomeFirstResponder];
        }
        else if (textField == self.accountTextField)
        {
            [textField resignFirstResponder];
            [self.ssnTextField becomeFirstResponder];
        }
    }
    else 
    {
        if (textField == self.idTextField)
        {
            [textField resignFirstResponder];
            [self.userFirstNameTextField becomeFirstResponder];
        }
        else if (textField == self.userFirstNameTextField)
        {
            [textField resignFirstResponder];
            [self.userLastNameTextField becomeFirstResponder];
        }
        else if (textField == self.userLastNameTextField)
        {
            [textField resignFirstResponder];
            [self.passwordTextField becomeFirstResponder];
        }
        else if (textField == self.passwordTextField)
        {
            [textField resignFirstResponder];
            [self.idTextField becomeFirstResponder];
        }
    }
    return YES;
}

- (void)textFieldDidBeginEditing:(UITextField *)textField
{
    if (textField == self.dobTextField)
    {
        [textField resignFirstResponder];
    }
    else if (textField == self.genderTextField)
    {
        [textField resignFirstResponder];
    }
    else if (textField == self.suffixTextField)
    {
        [textField resignFirstResponder];
    }
}

#pragma mark - Storyboard methods
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    if ([segue.identifier isEqualToString:@"DOBSegue"])
    {
        UINavigationController *navigationController = segue.destinationViewController;
        DateOfBirthViewController *controller = (DateOfBirthViewController *)navigationController.topViewController;
        controller.delegate = self;
    }
    else if ([segue.identifier isEqualToString:@"GenderSegue"])
    {
        UINavigationController *navigationController = segue.destinationViewController;
        GenderViewController *controller = (GenderViewController *)navigationController.topViewController;
        controller.delegate = self;
    }
    else if ([segue.identifier isEqualToString:@"SuffixSegue"])
    {
        UINavigationController *navigationController = segue.destinationViewController;
        SuffixViewController *controller = (SuffixViewController *)navigationController.topViewController;
        controller.delegate = self;
    }
    
    // setting delegate for popover so we can dismiss the popover later
    UIStoryboardPopoverSegue *popoverSegue;
    popoverSegue = (UIStoryboardPopoverSegue *)segue;
    self.popoverViewController = popoverSegue.popoverController;
    self.popoverViewController.delegate = self;
}

#pragma mark - Gender Suffix View Delegates
- (void)genderViewController:(GenderViewController *)controller didSelectGender:(NSString *)selectedGender
{
    self.genderTextField.text = selectedGender;
    [self.popoverViewController dismissPopoverAnimated:YES];
    
    //[self.lastNameTextField becomeFirstResponder];
}

- (void)suffixViewController:(SuffixViewController *)controller didSelectSuffix:(NSString *)selectedSuffix
{
    self.suffixTextField.text = selectedSuffix;
    [self.popoverViewController dismissPopoverAnimated:YES];
    
    //[self.mrnTextField becomeFirstResponder];
}

#pragma mark - Date Of Birth Delegates
- (void)dateOfBirthViewController:(DateOfBirthViewController *)controller didSelectDate:(NSDate *)selectedDate
{
    selectedBirthDate = selectedDate;
    self.dobTextField.text = [dateFormatter stringFromDate:selectedDate];
    [self.popoverViewController dismissPopoverAnimated:YES];
    
    //[self.genderTextField becomeFirstResponder];
}

#pragma mark - Other Methods
- (BOOL)clinicianAlreadyExist
{
    BOOL found = NO;
    int index = 0;
    
    while (index < [self.thePatient.myClinicians count] && !found)
    {
        if ([[self.thePatient.myClinicians objectAtIndex:index]  isEqualToString:self.clinicianID])
        {
            found = YES;
        }
        index++;
    }
    
    return found;
}

@end
