//
//  AdmitPatientViewController.h
//  MediServe
//
//  Created by Christopher Galindo on 4/12/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "Patient.h"
#import "AdmittedDateViewController.h"

@class AdmitPatientViewController;

@protocol AdmitPatientViewControllerDelegate <NSObject>

- (void)AdmitPatientViewController:(AdmitPatientViewController *)controller didAdmitPatient:(Patient *)admittedPatient;
- (void)AdmitPatientViewControllerDidCancel:(AdmitPatientViewController *)controller;

@end

@interface AdmitPatientViewController : UIViewController <UITextFieldDelegate, AdmittedDateViewControllerDelegate, UIPopoverControllerDelegate>

@property (weak, nonatomic) id<AdmitPatientViewControllerDelegate> delegate;
@property (strong, nonatomic) Patient *admitPatient;
@property (strong, nonatomic) IBOutlet UITextField *admitDate;
@property (strong, nonatomic) IBOutlet UITextField *admitTime;
@property (strong, nonatomic) IBOutlet UITextField *admitRoom;
@property (strong, nonatomic) IBOutlet UITextField *admitBed;
@property (strong, nonatomic) IBOutlet UITextField *admitUnit;
@property (strong, nonatomic) IBOutlet UILabel *errorLabel;
@property (strong, nonatomic) UIPopoverController *popoverViewController;

- (IBAction)saveButtonPressed;
- (IBAction)cancelButtonPressed;


@end
