//
//  AdmitPatientViewController.m
//  MediServe
//
//  Created by Christopher Galindo on 4/12/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "AdmitPatientViewController.h"

@implementation AdmitPatientViewController

@synthesize delegate = _delegate;
@synthesize admitPatient = _admitPatient;
@synthesize admitDate = _admitDate;
@synthesize admitTime = _admitTime;
@synthesize admitRoom = _admitRoom;
@synthesize admitBed = _admitBed;
@synthesize admitUnit = _admitUnit;
@synthesize errorLabel = _errorLabel;
@synthesize popoverViewController = _popoverViewController;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
    
    
    self.admitRoom.text = self.admitPatient.admitRoom;
    self.admitBed.text = self.admitPatient.admitBed;
    self.admitUnit.text = self.admitPatient.admitUnit;
    
    // Showing current date and time in textfields
    NSDate *currentDate = [[NSDate alloc] init];
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    
    [dateFormatter setDateStyle:NSDateFormatterShortStyle];
    self.admitDate.text = [dateFormatter stringFromDate:currentDate];
    
    [dateFormatter setDateStyle:NSDateFormatterNoStyle];
    [dateFormatter setTimeStyle:NSDateFormatterShortStyle];
    self.admitTime.text = [dateFormatter stringFromDate:currentDate];
}

- (void)viewDidUnload
{
    [self setAdmitDate:nil];
    [self setAdmitTime:nil];
    [self setAdmitRoom:nil];
    [self setAdmitBed:nil];
    [self setAdmitUnit:nil];
    [self setErrorLabel:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
	return YES;
}

#pragma mark - IBAction Methods
- (IBAction)saveButtonPressed
{
    Patient *admittedPatient = [[Patient alloc] init];
    admittedPatient = self.admitPatient;
    
    // validating input text fields
    if ([self.admitRoom.text length] > 0 && [self.admitBed.text length] > 0 && [self.admitUnit.text length] > 0)
    {
        admittedPatient.admitDate = self.admitDate.text;
        admittedPatient.admitTime = self.admitTime.text;
        admittedPatient.admitRoom = self.admitRoom.text;
        admittedPatient.admitBed = self.admitBed.text;
        admittedPatient.admitUnit = self.admitUnit.text;
        admittedPatient.isAdmitted = YES;
        
        [self.delegate AdmitPatientViewController:self didAdmitPatient:admittedPatient];
    }
    else if ([self.admitRoom.text length] == 0 && [self.admitBed.text length] == 0 && [self.admitUnit.text length] == 0)
    {
        admittedPatient.admitDate = self.admitDate.text;
        admittedPatient.admitTime = self.admitTime.text;
        admittedPatient.isAdmitted = YES;
        
        [self.delegate AdmitPatientViewController:self didAdmitPatient:admittedPatient];
    }
}

- (IBAction)cancelButtonPressed
{
    [self.delegate AdmitPatientViewControllerDidCancel:self];
}

#pragma mark - Text Field Delegates
- (void)textFieldDidBeginEditing:(UITextField *)textField
{
    if (textField == self.admitDate)
    {
        [textField resignFirstResponder];
    }
    else if (textField == self.admitTime)
    {
        [textField resignFirstResponder];
    }
}

#pragma mark - Storyboard methods
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    UINavigationController *navigationController = segue.destinationViewController;
    AdmittedDateViewController *controller = (AdmittedDateViewController *)navigationController.topViewController;
    controller.delegate = self;
    
    // setting delegate for popover so we can dismiss the popover later
    UIStoryboardPopoverSegue *popoverSegue;
    popoverSegue = (UIStoryboardPopoverSegue *)segue;
    self.popoverViewController = popoverSegue.popoverController;
    self.popoverViewController.delegate = self;
}

#pragma mark - Admitted Date Delegates
- (void)admittedDateViewController:(AdmittedDateViewController *)controller didSelectDate:(NSString *)selectedDate andSelectedTime:(NSString *)selectedTime
{
    self.admitDate.text = selectedDate;
    self.admitTime.text = selectedTime;
    
    [self.popoverViewController dismissPopoverAnimated:YES];
}

- (void)admittedDateViewControllerDidCancel:(AdmittedDateViewController *)controller
{
    [self.popoverViewController dismissPopoverAnimated:YES];
}

@end
