//
//  LoginViewController.h
//  MediServe
//
//  Created by Christopher Galindo on 3/23/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>

@class LoginViewController;
@class User;

@protocol LoginViewControllerDelegate <NSObject>

- (void)LoginViewController:(LoginViewController *)controller didValidateUser:(User *)userObject withUsers:(NSMutableArray *)usersArray;

@end

@interface LoginViewController : UIViewController <UITextFieldDelegate>

@property (strong, nonatomic) IBOutlet UITextField *idTextField;
@property (strong, nonatomic) IBOutlet UITextField *passwordTextField;
@property (strong, nonatomic) IBOutlet UILabel *messageLabel;
@property (nonatomic, weak) id<LoginViewControllerDelegate> delegate;
@property (strong, nonatomic) IBOutlet UITextField *idChangePassTextField;
@property (strong, nonatomic) IBOutlet UITextField *currentPassTextField;
@property (strong, nonatomic) IBOutlet UITextField *theNewPassTextField;
@property (strong, nonatomic) IBOutlet UITextField *confirmPassTextField;
@property (strong, nonatomic) IBOutlet UIButton *okButton;
@property (strong, nonatomic) IBOutlet UIButton *cancelButton;
@property (strong, nonatomic) IBOutlet UIButton *loginButton;
@property (strong, nonatomic) IBOutlet UIButton *changePassword;
@property (strong, nonatomic) NSMutableArray *usersList;

- (IBAction)loginButtonPressed;
- (IBAction)changePassButtonPressed;
- (IBAction)okButtonPressed;
- (IBAction)cancelButtonPressed;

@end
