//
//  LoginViewController.m
//  MediServe
//
//  Created by Christopher Galindo on 3/23/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "LoginViewController.h"
#import "User.h"

@implementation LoginViewController

@synthesize idTextField = _idTextField;
@synthesize passwordTextField = _passwordTextField;
@synthesize messageLabel = _messageLabel;
@synthesize delegate = _delegate;
@synthesize idChangePassTextField = _idChangePassTextField;
@synthesize currentPassTextField = _currentPassTextField;
@synthesize theNewPassTextField = _theNewPassTextField;
@synthesize confirmPassTextField = _confirmPassTextField;
@synthesize okButton = _okButton;
@synthesize cancelButton = _cancelButton;
@synthesize loginButton = _loginButton;
@synthesize changePassword = _changePassword;
@synthesize usersList = _usersList;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

/*
 // Implement loadView to create a view hierarchy programmatically, without using a nib.
 - (void)loadView
 {
 }
 */


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
    
    [self.idChangePassTextField setHidden:YES];
    [self.currentPassTextField setHidden:YES];
    [self.theNewPassTextField setHidden:YES];
    [self.confirmPassTextField setHidden:YES];
    [self.idChangePassTextField setEnabled:NO];
    [self.currentPassTextField setEnabled:NO];
    [self.theNewPassTextField setEnabled:NO];
    [self.confirmPassTextField setEnabled:NO];
    [self.okButton setHidden:YES];
    [self.cancelButton setHidden:YES];
    [self.okButton setEnabled:NO];
    [self.cancelButton setEnabled:NO];
    
    NSLog(@"number of users: %d", [self.usersList count]);
}

- (void)viewDidUnload
{
    [self setIdTextField:nil];
    [self setPasswordTextField:nil];
    [self setIdChangePassTextField:nil];
    [self setCurrentPassTextField:nil];
    [self setTheNewPassTextField:nil];
    [self setConfirmPassTextField:nil];
    [self setOkButton:nil];
    [self setCancelButton:nil];
    [self setLoginButton:nil];
    [self setChangePassword:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
	return YES;
}

- (void)loginButtonPressed
{
    BOOL found = NO;
    int index = 0;
    
    while (index < [self.usersList count] && (found == NO))
    {
        if ([self.idTextField.text isEqualToString:[[self.usersList objectAtIndex:index] userID]])
        {
            if ([self.passwordTextField.text isEqualToString:[[self.usersList objectAtIndex:index] userPassword]])
            {
                found = YES;
                [self.delegate LoginViewController:self didValidateUser:[self.usersList objectAtIndex:index] withUsers:self.usersList];
            }
        }
        index++;
    }
    
    if (!found)
    {
        self.messageLabel.text = @"The ID and/or Password provided are invalid";
    }
}

- (IBAction)changePassButtonPressed
{
    self.messageLabel.text = @"Please change your password";
    
    [self.idTextField setHidden:YES];
    [self.passwordTextField setHidden:YES];
    [self.changePassword setHidden:YES];
    [self.loginButton setHidden:YES];
    [self.idTextField setEnabled:NO];
    [self.passwordTextField setEnabled:NO];
    [self.changePassword setEnabled:NO];
    [self.loginButton setEnabled:NO];
    self.idTextField.text = @"";
    self.passwordTextField.text = @"";
    
    [self.idChangePassTextField setHidden:NO];
    [self.currentPassTextField setHidden:NO];
    [self.theNewPassTextField setHidden:NO];
    [self.confirmPassTextField setHidden:NO];
    [self.idChangePassTextField setEnabled:YES];
    [self.currentPassTextField setEnabled:YES];
    [self.theNewPassTextField setEnabled:YES];
    [self.confirmPassTextField setEnabled:YES];
    [self.okButton setHidden:NO];
    [self.cancelButton setHidden:NO];
    [self.okButton setEnabled:YES];
    [self.cancelButton setEnabled:YES];
}

- (IBAction)okButtonPressed 
{
    BOOL found = NO;
    BOOL userAndPassMatch = NO;
    int index = 0;
    
    while (index < [self.usersList count] && found == NO)
    {
        if ([[[self.usersList objectAtIndex:index] userID] isEqualToString:self.idChangePassTextField.text])
        {
            found = YES;
            if ([[[self.usersList objectAtIndex:index] userPassword] isEqualToString:self.currentPassTextField.text])
            {
                userAndPassMatch = YES;
                if ([self.theNewPassTextField.text isEqualToString:self.confirmPassTextField.text])
                {
                    User *userObject = [self.usersList objectAtIndex:index];
                    userObject.userPassword = self.theNewPassTextField.text;
                    [self cancelButtonPressed];
                    self.messageLabel.text = @"Password change successful";
                }
                else 
                {
                    self.messageLabel.text = @"The Confirm Password does not match the New Password";
                }
            }
        }
        index++;
    }
    
    if (!userAndPassMatch)
    {
        self.idChangePassTextField.text = @"";
        self.currentPassTextField.text = @"";
        self.theNewPassTextField.text = @"";
        self.confirmPassTextField.text = @"";
        [self.idChangePassTextField becomeFirstResponder];
    }
}

- (IBAction)cancelButtonPressed 
{
    [self.idTextField setHidden:NO];
    [self.passwordTextField setHidden:NO];
    [self.changePassword setHidden:NO];
    [self.loginButton setHidden:NO];
    [self.idTextField setEnabled:YES];
    [self.passwordTextField setEnabled:YES];
    [self.changePassword setEnabled:YES];
    [self.loginButton setEnabled:YES];
    
    [self.idChangePassTextField setHidden:YES];
    [self.currentPassTextField setHidden:YES];
    [self.theNewPassTextField setHidden:YES];
    [self.confirmPassTextField setHidden:YES];
    [self.idChangePassTextField setEnabled:NO];
    [self.currentPassTextField setEnabled:NO];
    [self.theNewPassTextField setEnabled:NO];
    [self.confirmPassTextField setEnabled:NO];
    [self.okButton setHidden:YES];
    [self.cancelButton setHidden:YES];
    [self.okButton setEnabled:NO];
    [self.cancelButton setEnabled:NO];
    
    self.idChangePassTextField.text = @"";
    self.currentPassTextField.text = @"";
    self.theNewPassTextField.text = @"";
    self.confirmPassTextField.text = @""; 
    self.messageLabel.text = @"";
}

#pragma mark - Text Field Delegates
- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
    if ([self.idChangePassTextField isHidden])
    {
        if (textField == self.idTextField)
        {
            [textField resignFirstResponder];
            [self.passwordTextField becomeFirstResponder];
        }
        else if (textField == self.passwordTextField)
        {
            [textField resignFirstResponder];
            [self.idTextField becomeFirstResponder];
        }
    }
    else
    {
        if (textField == self.idChangePassTextField)
        {
            [textField resignFirstResponder];
            [self.currentPassTextField becomeFirstResponder];
        }
        else if (textField == self.currentPassTextField)
        {
            [textField resignFirstResponder];
            [self.theNewPassTextField becomeFirstResponder];
        }
        else if (textField == self.theNewPassTextField)
        {
            [textField resignFirstResponder];
            [self.confirmPassTextField becomeFirstResponder];
        }
        else if (textField == self.confirmPassTextField)
        {
            [textField resignFirstResponder];
            [self.idChangePassTextField becomeFirstResponder];
        }
    }
    return YES;
}

@end
