//
//  Patient.m
//  MediServe
//
//  Created by Christopher Galindo on 3/26/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "Patient.h"

@implementation Patient

@synthesize firstName = _firstName;
@synthesize lastName = _lastName;
@synthesize myClinicians = _myClinicians;
@synthesize isActive = _isActive;
@synthesize displayName = _displayName;
@synthesize ssn = _ssn;
@synthesize birthDate = _birthDate;
@synthesize middleName = _middleName;
@synthesize mrn = _mrn;
@synthesize account = _account;
@synthesize gender = _gender;
@synthesize suffix = _suffix;
@synthesize isAdmitted = _isAdmitted;
@synthesize isDischarged = _isDischarged;
@synthesize admitBed = _admitBed;
@synthesize admitDate = _admitDate;
@synthesize admitRoom = _admitRoom;
@synthesize admitTime = _admitTime;
@synthesize admitUnit = _admitUnit;
@synthesize dischargeDate = _dischargeDate;
@synthesize patientImageData = _patientImageData;

// Serializing variables so data can be saved to the device
- (void)encodeWithCoder:(NSCoder *)aCoder
{
    [aCoder encodeObject:self.firstName forKey:@"FirstName"];
    [aCoder encodeObject:self.lastName forKey:@"LastName"];
    [aCoder encodeObject:self.myClinicians forKey:@"MyClinicians"];
    [aCoder encodeBool:self.isActive forKey:@"Active"];
    [aCoder encodeObject:self.displayName forKey:@"DisplayName"];
    [aCoder encodeObject:self.ssn forKey:@"SSN"];
    [aCoder encodeObject:self.birthDate forKey:@"BirthDate"];
    [aCoder encodeObject:self.middleName forKey:@"MiddleName"];
    [aCoder encodeObject:self.mrn forKey:@"MRN"];
    [aCoder encodeObject:self.account forKey:@"Account"];
    [aCoder encodeObject:self.gender forKey:@"Gender"];
    [aCoder encodeObject:self.suffix forKey:@"Suffix"];
    [aCoder encodeBool:self.isAdmitted forKey:@"Admitted"];
    [aCoder encodeBool:self.isDischarged forKey:@"Discharged"];
    [aCoder encodeObject:self.admitTime forKey:@"AdmitTime"];
    [aCoder encodeObject:self.admitRoom forKey:@"AdmitRoom"];
    [aCoder encodeObject:self.admitBed forKey:@"AdmitBed"];
    [aCoder encodeObject:self.admitDate forKey:@"AdmitDate"];
    [aCoder encodeObject:self.admitUnit forKey:@"AdmitUnit"];
    [aCoder encodeObject:self.dischargeDate forKey:@"DischargeDate"];
    [aCoder encodeObject:self.patientImageData forKey:@"PatientImage"];
}

- (id)initWithCoder:(NSCoder *)aDecoder
{
    if ((self =[super init]))
    {
        self.firstName = [aDecoder decodeObjectForKey:@"FirstName"];
        self.lastName = [aDecoder decodeObjectForKey:@"LastName"];
        self.myClinicians = [aDecoder decodeObjectForKey:@"MyClinicians"];
        self.isActive = [aDecoder decodeBoolForKey:@"Active"];
        self.displayName = [aDecoder decodeObjectForKey:@"DisplayName"];
        self.ssn = [aDecoder decodeObjectForKey:@"SSN"];
        self.birthDate = [aDecoder decodeObjectForKey:@"BirthDate"];
        self.middleName = [aDecoder decodeObjectForKey:@"MiddleName"];
        self.mrn = [aDecoder decodeObjectForKey:@"MRN"];
        self.account = [aDecoder decodeObjectForKey:@"Account"];
        self.suffix = [aDecoder decodeObjectForKey:@"Suffix"];
        self.gender = [aDecoder decodeObjectForKey:@"Gender"];
        self.isDischarged = [aDecoder decodeBoolForKey:@"Discharged"];
        self.isAdmitted = [aDecoder decodeBoolForKey:@"Admitted"];
        self.admitUnit = [aDecoder decodeObjectForKey:@"AdmitUnit"];
        self.admitTime = [aDecoder decodeObjectForKey:@"AdmitTime"];
        self.admitRoom = [aDecoder decodeObjectForKey:@"AdmitRoom"];
        self.admitDate = [aDecoder decodeObjectForKey:@"AdmitDate"];
        self.admitBed = [aDecoder decodeObjectForKey:@"AdmitBed"];
        self.dischargeDate = [aDecoder decodeObjectForKey:@"DischargeDate"];
        self.patientImageData = [aDecoder decodeObjectForKey:@"PatientImage"];
    }
    return self;
}

@end
